<?php
/**************************************************
  Coppermine 1.5.x Plugin - Edit pic's keywords selecting pics with the mouse
  *************************************************
  Copyright (c) 2013 Alejandro Lorente (http://www.eidansoft.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *********************************************
  $HeadURL$
  $Revision$ 1
  $LastChangedBy$ Alejandro Lorente
  $Date$ 03/05/2013
  **************************************************/
require_once "./plugins/graphic_keywords_editor/initialize.inc.php";

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// PLUGINS ACTIONS ///////////////////////////////////////
// install
$thisplugin->add_action('plugin_install','install');
// uninstall
$thisplugin->add_action('plugin_uninstall','uninstall');
// Pongo un manejador a page_start para dar de alta los JS, porque para que pille los JS es necesario 
//enlazarlo en ese HOOK que es el que genera las cabeceras, en otro caso no meteria
//el JS
$thisplugin->add_action('page_start','incluirJavascripts');

// PLUGIN FILTERS ////////////////////////////////////////
$thisplugin->add_filter('page_meta','incluirCSS');
//$thisplugin->add_filter('sys_menu','add_sub_button'); // I tried to use this hooks but not work
//$thisplugin->add_filter('admin_menu','add_admin_button'); // I tried to use this hooks but not work

// PLUGIN FUNCTIONS //////////////////////////////////////
function install() {
    global $CONFIG;
	// Create config options for the plugin. Una variable en BD para que quede constancia como se crean
	// Para usarla seria tan simple como leer o escribir en $CONFIG['plugin_graphic_keywords_editor_test']
	// Habiendo declarado como global $CONFIG en la funcion donde la vaya a usar
	cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_graphic_keywords_editor_test', 'http://www.eidansoft.com')");
    return true;
}

function uninstall() {
	global $CONFIG, $lang_errors;
	$superCage = Inspekt::makeSuperCage();
	if (!checkFormToken()) {
		cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
	}
	// Delete the plugin config records
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_graphic_keywords_editor_test'");
	return true;
}

function incluirJavascripts() {
	global $JS, $CONFIG, $lang_plugin_graphic_keywords_editor, $USER_DATA;
//	if (GALLERY_ADMIN_MODE) {
	// Si el usuario esta registrado (no es un anonimo/Guest)...
	if ($USER_DATA["user_id"] != 0) { 
		//Establezco las variables necesarias para el javascript
		set_js_var('separadorKeywords', $CONFIG['keyword_separator']);
		set_js_var('resultado', $lang_plugin_graphic_keywords_editor['txtJsResultado']);
		set_js_var('txtJsBtnTitle', $lang_plugin_graphic_keywords_editor['txtJsBtnTitle']);
		set_js_var('txtJsBtnTexto', $lang_plugin_graphic_keywords_editor['txtJsBtnTexto']);
		set_js_var('txtJsInputHelp', $lang_plugin_graphic_keywords_editor['txtJsInputHelp']);
		set_js_var('txtJsBtnAddTitle', $lang_plugin_graphic_keywords_editor['txtJsBtnAddTitle']);
		set_js_var('txtJsBtnAddTexto', $lang_plugin_graphic_keywords_editor['txtJsBtnAddTexto']);
		set_js_var('txtJsBtnDelTitle', $lang_plugin_graphic_keywords_editor['txtJsBtnDelTitle']);
		set_js_var('txtJsBtnDelTexto', $lang_plugin_graphic_keywords_editor['txtJsBtnDelTexto']);
		set_js_var('txtJsBtnSetTitle', $lang_plugin_graphic_keywords_editor['txtJsBtnSetTitle']);
		set_js_var('txtJsBtnSetTexto', $lang_plugin_graphic_keywords_editor['txtJsBtnSetTexto']);
		set_js_var('txtJsBtnEmptyTitle', $lang_plugin_graphic_keywords_editor['txtJsBtnEmptyTitle']);
		set_js_var('txtJsBtnEmptyTexto', $lang_plugin_graphic_keywords_editor['txtJsBtnEmptyTexto']);
		set_js_var('txtJsBtnHelpTitle', $lang_plugin_graphic_keywords_editor['txtJsBtnHelpTitle']);
		set_js_var('txtJsBtnHelpTexto', $lang_plugin_graphic_keywords_editor['txtJsBtnHelpTexto']);
		set_js_var('op_add_keyword', $lang_plugin_graphic_keywords_editor['op_add_keyword']);
		set_js_var('op_del_keyword', $lang_plugin_graphic_keywords_editor['op_del_keyword']);
		set_js_var('op_set_keyword', $lang_plugin_graphic_keywords_editor['op_set_keyword']);
		set_js_var('msgConfirmacionDeleteKeyword', $lang_plugin_graphic_keywords_editor['msgConfirmacionDeleteKeyword']);
		set_js_var('txtVersion', $lang_plugin_graphic_keywords_editor['version']);
		//incluyo los javascript
		$JS['includes'][] = 'plugins/graphic_keywords_editor/jquery-1.9.1.js';
		$JS['includes'][] = 'plugins/graphic_keywords_editor/jquery-ui.js';
		$JS['includes'][] = 'plugins/graphic_keywords_editor/select2.js';
		$JS['includes'][] = 'plugins/graphic_keywords_editor/editTag.js';
	}
}

function incluirCSS(){
	$css = '<link rel="stylesheet" href="plugins/graphic_keywords_editor/style.css" type="text/css" />';
	$css .= '<link rel="stylesheet" href="plugins/graphic_keywords_editor/jquery-ui.css" type="text/css" />';
	$css .= '<link rel="stylesheet" href="plugins/graphic_keywords_editor/select2.css" type="text/css" />';
	return $css;
}

// I tried to use this hooks but not work
//function add_sub_button($menu) {
//    $new_button = array();
//    $new_button[0][0] = 'MENU LINK';
//    $new_button[0][1] = 'menu link';
//    $new_button[0][2] = './menu_link.php';
//    $new_button[0][3] = 'class_name';
//    $new_button[0][4] = '::';
//    $new_button[0][5] = 'rel="nofollow"';
//
//    array_splice($menu, count($menu)-1, 0, $new_button);
//
//    return $menu;
//}
//
//function add_admin_button($admin_menu){
//    $new_button = '<div class="admin_menu admin_float"><a href="./menu_link.php" title="menu link">MENU LINK</a></div>';
//    $look_for = '<!-- END export -->';
//    $admin_menu = str_replace($look_for, $look_for . $new_button, $admin_menu); 
//    
//    return $admin_menu;
//}

?>
