<?php
/**************************************************
  Coppermine 1.5.x Plugin - Edit pic's keywords selecting pics with the mouse
  *************************************************
  Copyright (c) 2013 Alejandro Lorente (http://www.eidansoft.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *********************************************
  $HeadURL$
  $Revision$ 1
  $LastChangedBy$ Alejandro Lorente
  $Date$ 03/05/2013
  **************************************************/
require_once "./plugins/graphic_keywords_editor/initialize.inc.php";
require_once "./plugins/graphic_keywords_editor/keywordsFunctions.inc.php";

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

/**
*  Funcion que devuelve verdadero o falso si la foto pasada por parametro pertenece al usuario actual
*/
function usuarioActualEsDueno($pid) {
	global $USER_DATA;
	$foto = obtenerDatosDeFotoPorId($pid);
	return ($foto["owner_id"] == $USER_DATA["user_id"]);
}

$op = $superCage->post->getAlnum('op');
$ids = rellenaIds($superCage->post->getRaw('ids'));
$keys = rellenaKeys($superCage->post->getRaw('keys'));
//sleep (5);
switch ($op) {
    case $lang_plugin_graphic_keywords_editor['op_add_keyword']:
	foreach ($ids as $pid){
		if (usuarioActualEsDueno($pid) || GALLERY_ADMIN_MODE){ //Si el usuario actual es el dueño o es aministrador
			foreach ($keys as $key){
				anadirKeywordAFotoPorId($pid, $key);
			}
			echo $pid." - Ok\n";
		} else {
			echo $pid." - ".$lang_plugin_graphic_keywords_editor['msgSoloPropietarioPuedeEditarKeywords']."\n";
		}
	}
	break;
    case $lang_plugin_graphic_keywords_editor['op_del_keyword']:
        foreach ($ids as $pid){
		if (usuarioActualEsDueno($pid) || GALLERY_ADMIN_MODE){
			foreach ($keys as $key){
				eliminarKeywordAFotoPorId($pid, $key);
			}
			echo $pid." - Ok\n";
		} else {
			echo $pid." - ".$lang_plugin_graphic_keywords_editor['msgSoloPropietarioPuedeEditarKeywords']."\n";
		}
	}
	break;
    case $lang_plugin_graphic_keywords_editor['op_set_keyword']:
        foreach ($ids as $pid){
		if (usuarioActualEsDueno($pid) || GALLERY_ADMIN_MODE){
			actualizaKeywords($pid, ""); //Elimino las palabras clave existentes para esa foto y le pongo las solicitadas
			foreach ($keys as $key){
				anadirKeywordAFotoPorId($pid, $key);
			}
			echo $pid." - Ok\n";
		} else {
			echo $pid." - ".$lang_plugin_graphic_keywords_editor['msgSoloPropietarioPuedeEditarKeywords']."\n";
		}
	}
	break;
}
//echo "FIN ".$op." ".$_POST["op"];
/*
echo "Ok he recibido:";
echo "\nOperacion: ".$superCage->post->getAlnum('op'); //$_POST["op"];
echo "\nIds: ".$superCage->post->getRaw('ids'); //$_POST["ids"];
*/

?>
