/**************************************************
  Coppermine 1.5.x Plugin - Edit pic's keywords selecting pics with the mouse
  *************************************************
  Copyright (c) 2013 Alejandro Lorente (http://www.eidansoft.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *********************************************
  $HeadURL$
  $Revision$ 1
  $LastChangedBy$ Alejandro Lorente
  $Date$ 03/05/2013
  **************************************************/

/**
*  Funcion que activa/desactiva la seleccion de fotos, esta es la funcion que llamara el boton del menu
*/
function toggleEditTags(){
	if ( jQuery19( ".ui-selectee" ).length > 0 ){
		endEditTags();
	} else {
		startEditTags();
	}
};

/**
*  Funcion que activa la seleccion de fotos
*/
function startEditTags(){
	//alert("Ahora puedes seleccionar las imagenes con el raton y modificar sus etiquetas");

	//deshabilito el enlace de las imagenes y hago que al hacer clic en la imagen esta se seleccione
	jQuery19( "a .image" ).click(function(e) {
		if ( jQuery19(this).parents("td.thumbnails").hasClass("ui-selected") ){
			jQuery19(this).parents("td.thumbnails").removeClass("ui-selected");
		} else {
			jQuery19(this).parents("td.thumbnails").addClass("ui-selected");
		}
		e.preventDefault();
	});
	
	//pongo seleccionable los elementos de las imagenes
	jQuery19( "table.maintable" ).selectable({
		filter: "td.thumbnails",
		distance: 1,
	});

	//Establezco que el DIV que muestra las keywords siga al raton donde vaya
	jQuery19(document).bind('mousemove', function(e){
		$('#pictureKeywords').css({
		left:  e.pageX-75,
		top:   e.pageY+15
		});
	});

	//Muestro el menu
	jQuery19( "#tagMenu" ).show();
};

/**
*  Funcion que desactiva la seleccion de imagenes
*/
function endEditTags(){
	//Si hay alguna foto seleccionada, la desselecciono
	jQuery19( ".ui-selected" ).each(function( index ) {
		jQuery19(this).removeClass("ui-selected");
	});
	//Quito la funcionalidad de seleccion
	jQuery19( "table.maintable" ).selectable( "destroy" );

	//reactivo los enlace de las imagenes
	jQuery19( "a .image" ).unbind('click'); //.click(function(e) { return true; });

	//Desactivo el seguimiento al raton por parte del DIV que muestra las palabras clave
	jQuery19( document ).unbind('mousemove');

	//Oculto el menu
	jQuery19( "#tagMenu" ).hide();
};

/**
*  Funcion encargada de descargarse todas las palabras clave existentes en la BD
*  y ponerlas en el buffer, para que esten disponibles para su uso por el autocompletar
*  de la libreria select2
*/
function actualizaBufferKeys(){
	jQuery19.post("index.php?file=graphic_keywords_editor/getAllKeywords", {
		//term: jQuery19( "li.select2-search-field input" ).val(), //realmente no es necesario mandarle nada, ya que esta funcion en el servidor me devolvera todas las palabras clave existentes
	},
	function(data,status){
		jQuery19( "#txtBufferKeys" ).val(data);
	});
}

/**
*  Funcion encargada de procesar los IDs de las imagenes seleccionadas y realizar la peticion
*  al servidor para realizar la tarea correspondiente, para ello envia al servidor todos los datos
*  que necesita.
*/
function processSelectedPicturesIds(){
	if(jQuery19( "#txtOp" ).val() == js_vars.op_add_keyword || confirm(js_vars.msgConfirmacionDeleteKeyword)){
		jQuery19( "#imgEsperaEditarEtiqueta" ).show();
		jQuery19( "#txtPicsIds" ).val("");
		jQuery19( ".ui-selected table a .image").each(function( index ) {
			var pid = jQuery19(this).parent().attr("href").toString().match(/pid=([^&|^#]+)/)[1];
			jQuery19( "#txtPicsIds" ).val(pid + js_vars.separadorKeywords + jQuery19( "#txtPicsIds" ).val());
		});
		//alert(jQuery19( "#txtPicsIds" ).val());

		//hago la peticion al servidor para que edite las palabras clave de las fotos
		jQuery19.post("index.php?file=graphic_keywords_editor/editKeywords",
			{
				op: jQuery19( "#txtOp" ).val(),
				ids: jQuery19( "#txtPicsIds" ).val(),
				keys: jQuery19( "#txtTags" ).val(),
			},
		function(data,status){
			jQuery19( "#imgEsperaEditarEtiqueta" ).hide();
			alert(js_vars.resultado + ": " + data);
		});
		//Tras realizar la operacion, es posible que la lista de las palabras claves haya cambiado
		//asi que la actualizo
		actualizaBufferKeys();
	}
};

//function pruebas(){
//	jQuery19.post("index.php?file=graphic_keywords_editor/empty_keywords_pics",
//		{
//		},
//	function(data,status){
//		alert(js_vars.resultado + ": " + data);
//	});
//}

// INICIO del Script
jQuery19(document).ready(function() {
	//pruebas();
	//Si me encuentro en la pagina de thumnails
	var ruta = window.location.pathname;
	if (ruta.search( 'thumbnails.php' ) > 0){
		//Pongo el boton para activar la edicion de las etiquetas
		//jQuery19( ".buttonlist ul " ).append('<li><a href="#" title="Editar etiquetas de las imagenes" id="btnEditTag"><span><img src="./plugins/graphic_keywords_editor/img/editTags.png" border="0" alt="" width="16" height="16" class="icon"></span></a></li>');
		jQuery19("#main_menu .dropmenu:last").append('<li><a class="firstlevel" title="'+js_vars.txtJsBtnTitle+'" href="#" id="btnEditTag"><span class="firstlevel"><img class="icon" width="16" height="16" border="0" alt="" src="./plugins/graphic_keywords_editor/img/editTags.png">'+js_vars.txtJsBtnTexto+'</span></a></li>');
		
		//El manejador del boton que acabo de crear
		jQuery19( "#btnEditTag" ).click(function() {
			toggleEditTags();
		});

		//creo el menu de edicion de etiquetas
		jQuery19("body").prepend('<div id="tagMenu"><input type="hidden" name="txtBufferKeys" id="txtBufferKeys" /><input type="hidden" name="txtOp" id="txtOp" /><input type="hidden" name="txtPicsNames" id="txtPicsNames" /><input type="hidden" name="txtPicsIds" id="txtPicsIds" /><nav id="main_navigation" class="floating_nav"><ul><li><input type="text" name="txtTags" id="txtTags" placeholder="'+js_vars.txtJsInputHelp+'" title="'+js_vars.txtJsInputHelp+'" /><img id="imgEsperaEditarEtiqueta" src="./plugins/graphic_keywords_editor/img/spinner.gif" /></li><li><a href="#" title="'+js_vars.txtJsBtnAddTitle+'" id="btnAddTags">'+js_vars.txtJsBtnAddTexto+'</a></li><li><a href="#" title="'+js_vars.txtJsBtnDelTitle+'" id="btnRemoveTags">'+js_vars.txtJsBtnDelTexto+'</a></li><li><a href="#" title="'+js_vars.txtJsBtnSetTitle+'" id="btnReplaceTags">'+js_vars.txtJsBtnSetTexto+'</a></li><li><a href="index.php?file=graphic_keywords_editor/empty_keywords_pics" title="'+js_vars.txtJsBtnEmptyTitle+'" id="btnEmptyTags">'+js_vars.txtJsBtnEmptyTexto+'</a></li><li><a href="http://www.eidansoft.com/blog/plugin-coppermine-graphic_keywords_editor/" title="'+js_vars.txtJsBtnHelpTitle+'" id="btnHelp">'+js_vars.txtJsBtnHelpTexto+' ('+js_vars.txtVersion+')</a></li></ul></nav></div>');
		jQuery19( "#imgEsperaEditarEtiqueta" ).hide();
		//Creo los manejadores de los botones del menu de edicion de etiquetas
		jQuery19( "#btnAddTags" ).click(function(e) {
			jQuery19( "#txtOp" ).val(js_vars.op_add_keyword);
			processSelectedPicturesIds();
			e.preventDefault();
		});
		jQuery19( "#btnRemoveTags" ).click(function(e) {
			jQuery19( "#txtOp" ).val(js_vars.op_del_keyword);
			processSelectedPicturesIds();
			e.preventDefault();
		});
		jQuery19( "#btnReplaceTags" ).click(function(e) {
			jQuery19( "#txtOp" ).val(js_vars.op_set_keyword);
			processSelectedPicturesIds();
			e.preventDefault();
		});

		//Me decargo la lista completa de palabras clave existente en la BD y creo la funcion de autocompletar las etiquetas
		actualizaBufferKeys();
		jQuery19("#txtTags").select2({
			//tags:["red", "green", "blue", "amor"],
			tags: function () {
				return jQuery19.parseJSON(jQuery19( "#txtBufferKeys" ).val());
			},
			separator: js_vars.separadorKeywords,
			tokenSeparators: [js_vars.separadorKeywords],
			minimumInputLength: 1,
		});

		//De momento el menu estara oculto
		jQuery19( "#tagMenu" ).hide();

		// Creo el DIV que muestra las etiquetas de cada imagenes y que de momento estara oculto
		jQuery19("body").prepend('<div id="pictureKeywords"><input type="hidden" id="txtPictureIdMouseOver" name="txtPictureIdMouseOver" /><img id="imgEsperaEtiquetas" src="./plugins/graphic_keywords_editor/img/spinner.gif" /><p></p></div>');
		jQuery19( "#pictureKeywords" ).hide();
		// Y el manejador que mostrara el div cada vez que pase el raton por encima de una imagenes
		jQuery19( "table.maintable td.thumbnails" ).hover(
			function () {
				// Si estamos editando las palabras clave
				if ( jQuery19( ".ui-selectee" ).length > 0 ){
					//obtengo el id de la imagen sobre la que me encuentro y la almaceno en #txtPictureIdMouseOver
					var pid = jQuery19(this).find("table td a").attr("href").toString().match(/pid=([^&|^#]+)/)[1];
					jQuery19( "#txtPictureIdMouseOver" ).val(pid);
					//Muestro el DIV con la imagen de espera
					jQuery19( "#pictureKeywords" ).show();
					jQuery19( "#imgEsperaEtiquetas" ).show();
					//hago la peticion al servidor
					jQuery19.post("index.php?file=graphic_keywords_editor/getKeywords",
						{
							id: jQuery19( "#txtPictureIdMouseOver" ).val(),
						},
					function(data,status){
						//Al recibir la respuesta la pongo en la etiqueta p del DIV y oculto la imagen de espera
						jQuery19("#pictureKeywords p").html(data.substring(0,255));						
						jQuery19( "#imgEsperaEtiquetas" ).hide();
					});
				}
			},
			function () {
				jQuery19( "#pictureKeywords" ).hide();
				jQuery19("#pictureKeywords p").html("");
			});

		//Hago destacar el boton de activar/desactivar la edicion de palabras clave
		jQuery19( "#btnEditTag" ).fadeOut(100).fadeIn(500).fadeOut(100).fadeIn(500).fadeOut(100).fadeIn(500);
	}
});


