<?php
/**************************************************
  Coppermine 1.5.x Plugin - Edit pic's keywords selecting pics with the mouse
  *************************************************
  Copyright (c) 2013 Alejandro Lorente (http://www.eidansoft.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *********************************************
  $HeadURL$
  $Revision$ 1
  $LastChangedBy$ Alejandro Lorente
  $Date$ 03/05/2013
  **************************************************/
require_once "./plugins/graphic_keywords_editor/initialize.inc.php";

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

/**
*  Devuelve un ARRAY con los datos en BD de una foto con el ID pasado por parametro
*/
function obtenerDatosDeFotoPorId($pid){
	global $CONFIG;
	//obtengo los datos de la foto en la BD
	$rst = cpg_db_query("SELECT * FROM ".$CONFIG['TABLE_PICTURES']." WHERE pid=".$pid);
	$datosFoto = mysql_fetch_array($rst);
	//$keywordsActuales = $keywordsActuales[0];
	mysql_free_result($rst);
	return $datosFoto;
}

/**
*  Devuelve un ARRAY con las palabras clave de una foto con el ID pasado por parametro
*/
function obtenerKeywordsDeFotoPorId($pid){
	global $CONFIG;
	//obtengo las palabras clave de la BD
	$foto = obtenerDatosDeFotoPorId($pid);
	$keywordsActuales = $foto["keywords"];
	//Devuelvo las palabras clave en un array
	if ($keywordsActuales != ""){
		$keywords = explode($CONFIG['keyword_separator'],$keywordsActuales);
	} else {
		$keywords = array();
	}
	return $keywords;
}

/**
*   Procedimiento encargado de actualizar el valor del campo de palabras clave para
*   una imagen identificada por su PID. El parametro $keywords es una cadena con las
*   palabras clave separadas por el caracter separador.
*/
function actualizaKeywords($pid, $keywords){
	global $CONFIG;
	cpg_db_query("UPDATE ".$CONFIG['TABLE_PICTURES']." SET keywords='".$keywords."' WHERE pid=".$pid);
}

/**
*   Procedimiento encargado de buscar todas las fotos SIN palabras clave y de
*   ponerles la palabra clave $lang_plugin_graphic_keywords_editor['empty_keyword']
*   para que puedan localizarse con facilidad mediante el buscador
*/
function marcaFotosSinKeywords(){
	global $CONFIG, $lang_plugin_graphic_keywords_editor, $USER_DATA;
	//Si lo ejecuta el usuario administrador NO hay filtro por ID (puede editar las etiquetas de las fotos
	//de cualquier usuario) Pero si es un usuario normal, filtramos para marcar solo las fotos de ese usuario
	if (GALLERY_ADMIN_MODE){
		cpg_db_query("UPDATE ".$CONFIG['TABLE_PICTURES']." SET keywords='".$lang_plugin_graphic_keywords_editor['empty_keyword'].$USER_DATA['user_name']."' WHERE keywords IS NULL OR keywords='' OR keywords LIKE '%".$lang_plugin_graphic_keywords_editor['empty_keyword']."%'");
	} else {
		cpg_db_query("UPDATE ".$CONFIG['TABLE_PICTURES']." SET keywords='".$lang_plugin_graphic_keywords_editor['empty_keyword'].$USER_DATA['user_name']."' WHERE owner_id=".$USER_DATA['user_id']." AND (keywords IS NULL OR keywords='' OR keywords LIKE '%".$lang_plugin_graphic_keywords_editor['empty_keyword']."%')");
	}
}
/**
*  Funcion que devuelve si la cadena pasada como parametro 1 comienza con la misma secuencia
*  de letras que la cadena pasada como parametro 2
*/
function startsWith($pajar, $aguja)
{
    return !strncmp($pajar, $aguja, strlen($aguja));
}

/**
*  Recibe un ID de una foto y una palabra clave, y le anade dicha palabra clave a la foto con ese ID
*/
function anadirKeywordAFotoPorId($pid, $nuevaKeyword){
	global $CONFIG, $lang_plugin_graphic_keywords_editor;
	$keywords = obtenerKeywordsDeFotoPorId($pid);
	if (!in_array($nuevaKeyword, $keywords)) {
		$keywordsAPoner = $nuevaKeyword;
		foreach ($keywords as $key){
			//Si la siguiente palabra clave NO es la etiqueta utilizada para marcar
			//las fotos sin palabras clave, la anado; si es esa etiqueta NO; para evitar
			//que despues de ponerle una etiqueta y volver a ejecutar la busqueda de
			//fotos sin palabras clave, se pierda esta palabra clave puesta en $nuevaKeyword
			if (! startsWith($key, $lang_plugin_graphic_keywords_editor['empty_keyword'])){
				$keywordsAPoner = $keywordsAPoner.$CONFIG['keyword_separator'].$key;
			}
		}
		actualizaKeywords($pid, $keywordsAPoner);
	}
}
/**
*  Recibe un ID de una foto y una palabra clave, y le elimina dicha palabra clave a la foto con ese ID
*/
function eliminarKeywordAFotoPorId($pid, $keywordAQuitar){
	global $CONFIG;
	$keywords = obtenerKeywordsDeFotoPorId($pid);
	//echo "Keys de la foto (PID ".$pid."): ".json_encode($keywords)."\n";
	for ($i = 0; $i < count($keywords); $i++){
		if ($keywords[$i] == $keywordAQuitar){
			unset($keywords[$i]);
		}
	}
	//echo "Keys despues de borrar: ".json_encode($keywords)."\n";
	$keywords = array_values($keywords); //Reindexo los indices para que no falten los numeros eliminados
	if (count($keywords) > 0){
		$palabrasClave = $keywords[0];
		for ($i = 1; $i < count($keywords); $i++){
			$palabrasClave = $palabrasClave.$CONFIG['keyword_separator'].$keywords[$i];
		}
	}
	//echo "Keys a String: ".$palabrasClave."\n";
	actualizaKeywords($pid, $palabrasClave);
}
/**
*  Transforma la cadena de IDs de foto separados por SEPARADOR (;) en un array de IDs. Ademas en el array final no hay ningun elemento vacio
*/
function rellenaIds($ids){
	global $CONFIG;
	//Saco los IDs a un array
	$arrayIds = explode($CONFIG['keyword_separator'],$ids);
	//Elimino el que este vacio (si lo hay)
	for ($i = 0; $i < count($arrayIds); $i++){
		if ($arrayIds[$i] == ""){
			unset($arrayIds[$i]);
		}
	}
	//unset($arrayIds[count($arrayIds)-1]);
	return array_values($arrayIds); //Reindexo los indices antes de enviar para que no falten los numeros eliminados
}
/**
*  Transforma la cadena de palabras clave separadas por SEPARADOR (;) en un array de palabras clave. Ademas en el array final no hay ningun elemento vacio
*/
function rellenaKeys($keys){
	global $CONFIG;
	//Saco las palabras clave a un array
	$arrayKeys = explode($CONFIG['keyword_separator'],$keys);
	//Elimino el que este vacio (si lo hay)
	for ($i = 0; $i < count($arrayKeys); $i++){
		if ($arrayKeys[$i] == ""){
			unset($arrayKeys[$i]);
		}
	}
	return array_values($arrayKeys); //Reindexo los indices antes de enviar para que no falten los numeros eliminados
}
/**
*  Devuelve un array con todas las palabras clave que tienen las fotos de la BD sin repetidos y sin elementos vacios
*/
function obtenerTodasLasKeywords(){
	global $CONFIG;
	//obtengo todas las palabras clave de la BD
	$rst = cpg_db_query("SELECT ALL keywords FROM ".$CONFIG['TABLE_PICTURES']);
	$keywordsActuales = array();
	while ($fila = mysql_fetch_array($rst)) {
	    $keywordsActuales[] = $fila[0];
	}
	mysql_free_result($rst);
	//Elimino elimino los elementos vacios (si lo hay) que son los de las fotos sin palabras clave
	for ($i = 0; $i < count($keywordsActuales); $i++){
		if (trim($keywordsActuales[$i]) == ""){
			unset($keywordsActuales[$i]);
		}
	}
	//Ahora tengo todos los campos KEYWORD de todas las fotos en el array $keywordsActuales[]
	//Para cada uno de esos campos necesito dividirlos en palabras clave individuales y unirlas todas en un array TOTAL llamado $keywordsIndividuales
	$keywordsIndividuales = array();
	if (count($keywordsActuales) > 0){
		foreach ($keywordsActuales as $claves){
			$keywordsIndividuales = array_merge ( $keywordsIndividuales, rellenaKeys($claves) );
		}
	}
	//Ahora tengo un array, donde cada elemento es UNA palabra clave, con todas las palabras claves de todas las imagenes; pero habra palabras que se encuentren duplicadas
	//Por lo que envio el array sin duplicados (unique) y reindexados (para que los indices se pongan bien de nuevo y no falten los numeros eliminados)	
	return array_values(array_unique($keywordsIndividuales));
}
?>
